# -*- coding: utf-8 -*-
"""
/***************************************************************************
 qgis2google
                                 A QGIS plugin
 qgis2google
                              -------------------
        begin                : 2013-10-17
        copyright            : (C) 2013 by qgis2google
        email                : qgis2google
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
# Import the PyQt and QGIS libraries
import qgis
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
# Initialize Qt resources from file resources.py
import resources_rc
# Import the code for the dialog
from qgis2googledialog import qgis2googleDialog
#import os.path
import os
import platform

class qgis2google:

    def __init__(self, iface):
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value("locale/userLocale")[0:2]
        localePath = os.path.join(self.plugin_dir, 'i18n', 'qgis2google_{}.qm'.format(locale))

        if os.path.exists(localePath):
            self.translator = QTranslator()
            self.translator.load(localePath)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlg = qgis2googleDialog()

    def initGui(self):
        # Create action that will start plugin configuration
        self.action = QAction(
            QIcon(":/plugins/qgis2google/icon.png"),
            u"qgis2google", self.iface.mainWindow())
        # connect the action to the run method
        self.action.triggered.connect(self.run)

        # Add toolbar button and menu item
        self.iface.addToolBarIcon(self.action)
        self.iface.addPluginToMenu(u"&qgis2google", self.action)

    def unload(self):
        # Remove the plugin menu item and icon
        self.iface.removePluginMenu(u"&qgis2google", self.action)
        self.iface.removeToolBarIcon(self.action)

    # run method that performs all the real work
    def run(self):

#        # show the dialog
#        self.dlg.show()
#        # Run the dialog event loop
#        result = self.dlg.exec_()
#        # See if OK was pressed
#        if result == 1:
#            # do something useful (delete the line containing pass and
#            # substitute with your code)
#            pass

#  Prendo le coordinate della view QGis------------------

        iface = qgis.utils.iface
        canvas = iface.mapCanvas()
        mapRenderer = canvas.mapRenderer()
        mapRect = mapRenderer.extent()
        width = mapRenderer.width()
        height = mapRenderer.height()
        srs = mapRenderer.destinationCrs()

        crsSrc = srs 
        crsDest = QgsCoordinateReferenceSystem(4326)  # Wgs84LLH
        xform = QgsCoordinateTransform(crsSrc, crsDest)

        x1 = mapRect.xMinimum()
        y1 = mapRect.yMinimum()
        
        x2 = mapRect.xMaximum()
        y2 = mapRect.yMinimum()

        x3 = mapRect.xMaximum()
        y3 = mapRect.yMaximum()

        x4 = mapRect.xMinimum()
        y4 = mapRect.yMaximum()

        pt1 = xform.transform(QgsPoint(x1, y1))        
        pt2 = xform.transform(QgsPoint(x2, y2))
        pt3 = xform.transform(QgsPoint(x3, y3))
        pt4 = xform.transform(QgsPoint(x4, y4))                        

        x1 = pt1.x()
        y1 = pt1.y()
        
        x2 = pt2.x()
        y2 = pt2.y()
        
        x3 = pt3.x()
        y3 = pt3.y()
        
        x4 = pt4.x()
        y4 = pt4.y()        

        
#  Prendo la directory temporanea all'interno del plugin ------------------------

        tempdir = QFileInfo(QgsApplication.qgisUserDbFilePath()).path() + "/python/plugins/qgis2google/temp"
              
        salvalo2 = open(tempdir + "/QGisLayer.kml",'w')
        salvalo2.write ('<?xml version="1.0" encoding="UTF-8"?>\n')
        salvalo2.write ('<kml xmlns="http://www.opengis.net/kml/2.2" xmlns:gx="http://www.google.com/kml/ext/2.2" xmlns:kml="http://www.opengis.net/kml/2.2" xmlns:atom="http://www.w3.org/2005/Atom">\n')

        salvalo2.write ('<Document>\n')
        salvalo2.write ('	<name>QGisLayer</name>\n')
        salvalo2.write ('	<open>1</open>\n')
            
        salvalo2.write (' <Folder>\n')
        xc = (x1 + x3) / 2.
        yc = (y1 + y3) / 2.
        dx = (x3 - x1) * 75000. #100000.
                
        salvalo2.write('    		<LookAt>\n')
        stringazza = ("    		   <longitude>%lf</longitude>\n") %(xc)
        salvalo2.write(stringazza)        
        stringazza = ("    		   <latitude>%lf</latitude>\n") %(yc)
        salvalo2.write(stringazza)        
        salvalo2.write('    		   <altitude>0</altitude>\n')
        salvalo2.write('    		   <heading>0.00</heading>\n')
        salvalo2.write('    		   <tilt>0</tilt>\n')
        stringazza = ("    		   <range>%lf</range>\n") %(dx)
        salvalo2.write(stringazza)        
        salvalo2.write('    		   <gx:altitudeMode>relativeToGround</gx:altitudeMode>\n')
        salvalo2.write('    		</LookAt>\n')
        
        layer = self.iface.mapCanvas().currentLayer()
        if layer:
            name = layer.source();

            iter = layer.getFeatures()
            for feat in iter:
            
              # fetch geometry
              geom = feat.geometry()

              # show some information about the feature
              
              if geom.type() == QGis.Point:
                elem = geom.asPoint()
                x1 = elem.x()
                y1 = elem.y()

                salvalo2.write ('	<Placemark>\n')
                salvalo2.write ('		<Point>\n')
                salvalo2.write ('			<gx:drawOrder>1</gx:drawOrder>\n')
                stringazza =   ('			<coordinates>%lf,%lf</coordinates>\n') % (x1,y1)
                salvalo2.write (stringazza)                                  
                salvalo2.write ('		</Point>\n')
                salvalo2.write ('	</Placemark>\n')


              elif geom.type() == QGis.Line:

                salvalo2.write ('	<Placemark>\n')
                salvalo2.write ('		<LineString>\n')
                salvalo2.write ('			<tessellate>1</tessellate>\n')
                salvalo2.write ('			<coordinates>\n')
                
                elem = geom.asPolyline()
                 
                for p1 in elem:
                  x1,y1 = p1.x(),p1.y()                             
                  stringazza =   ('%lf,%lf \n') % (x1,y1)
                  salvalo2.write (stringazza)
                  
                salvalo2.write ('			</coordinates>\n')                   
                salvalo2.write ('		</LineString>\n')
                salvalo2.write ('	</Placemark>\n')


              elif geom.type() == QGis.Polygon:

                salvalo2.write ('	<Placemark>\n')
                salvalo2.write ('		<Polygon>\n')
                salvalo2.write ('			<tessellate>1</tessellate>\n')
                salvalo2.write ('     <outerBoundaryIs>\n')
                salvalo2.write ('        <LinearRing>\n')
                salvalo2.write ('         <coordinates>\n')
              
                elem = geom.asPolygon()

                for iii in range (len(elem)):
                  for jjj in range (len(elem[iii])):
                                 
                    x1,y1 = elem[iii][jjj][0], elem[iii][jjj][1]

                    stringazza =   ('%lf,%lf,0 \n') % (x1,y1)
                    salvalo2.write (stringazza)

                salvalo2.write ('         </coordinates>\n')
                salvalo2.write ('        </LinearRing>\n')
                salvalo2.write ('     </outerBoundaryIs>\n')
                salvalo2.write ('   </Polygon>\n')
                
                salvalo2.write ('	</Placemark>\n')

        salvalo2.write ('</Folder>\n')
        salvalo2.write ('</Document>\n')        
        salvalo2.write ('</kml>\n')
        salvalo2.close()
        
        if platform.system() == "Windows":            
            os.startfile(tempdir + '/QGisLayer.kml')        
